Foreman - Bug #23611

ApplicationJob starts when foreman_tasks does not exist
05/16/2018 01:15 PM - Jonathon Turel

Status: Closed
Priority: Normal
Assignee: Adam Ruzicka
Category:
Target version: 1.18.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases: Nightly
Bugzilla link: 1581311 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/5575,
https://github.com/theforeman/foreman/p
ull/5682
Description

| discovered this while looking into an issue in Katello on the centos7-katello-nightly forklift VM but | suspect it'll show up after any
fresh installation.

Applicationdobs (using dynflow) are being started when foreman_tasks has not been fully initialized and this error can be seen from
several jobs across Foreman and Katello being started:

2018-05-03T00:50:19 [W|dyn|] Error on on_execution_plan_save event
ActiveRecord: :StatementInvalid: PG::UndefinedTable: ERROR: relation "foreman_tasks_tasks" does no

t exist
LINE 8: WHERE a.attrelid = '"foreman_tasks_tasks"'::r...
SELECT a.attname, format_type(a.atttypid, a.atttypmod),
pg_get_expr(d.adbin, d.adrelid), a.attnotnull, a.atttypid, a.atttypmod,
c.collname, col_description(a.attrelid, a.attnum) AS comment
FROM pg_attribute a
LEFT JOIN pg_attrdef d ON a.attrelid = d.adrelid AND a.attnum = d.adnum
LEFT JOIN pg_type t ON a.atttypid = t.oid
LEFT JOIN pg_collation ¢ ON a.attcollation = c.oid AND a.attcollation <> t.typcoll
ation

WHERE a.attrelid = '"foreman_tasks_tasks"'::regclass
AND a.attnum > 0 AND NOT a.attisdropped
ORDER BY a.attnum

| believe it comes down to a timing issue with how these components are installed; hoping to start & track discussion about it here. It
seems like even if the jobs do eventually start due to retry attempts, we shouldn't be throwing huge stack traces. | don't mind fixing
the problem, but some guidance would be appreciated. To add, it appears that the jobs do eventually start, but after several
attempts.

- should we expand ApplicationJob to not start jobs until foreman_tasks and/or dynflow are completely initialized?
- something else?

Related issues:

Related to Katello - Bug #23326: multiple paused state "Create Pulpdiskspace"... Closed 04/19/2018
Related to Foreman - Bug #22833: delayed_plan 'CreateRssNotifications' is fai... Duplicate 03/09/2018
Related to Foreman - Bug #23932: Applicationdob tests fail when run on jenkin... Closed 06/14/2018

Associated revisions

Revision e5b4634f - 06/11/2018 01:42 PM - Adam Ruzicka

e Fixes #23611 - Provide helper method to run "service" active jobs

The root cause was we were triggering the active jobs too early,
sometimes even before the db was migrated. This led to all sorts of
errors. The provided helper method does not trigger the jobs when in
any rake or in test environment. This helper should be reused in
Katello as well.

History

#1 - 05/16/2018 01:25 PM - Jonathon Turel
- Related to Bug #23326: multiple paused state "Create Pulpdiskspace" notifications is beng triggered in dynflow added

#2 - 05/18/2018 01:33 PM - Ivan Necas
- Project changed from foreman-tasks to Foreman

- Category deleted (Dynflow)

#3 - 05/22/2018 03:43 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Adam Ruzicka

- Pull request https://github.com/theforeman/foreman/pull/5575 added

#4 - 06/01/2018 12:10 PM - Marek Hulan
- Related to Bug #22833: delayed_plan 'CreateRssNotifications' is failing in 15sec intervals added

#5 - 06/01/2018 12:12 PM - Marek Hulan
- Bugzilla link set to 1581311

#6 - 06/11/2018 01:43 PM - lvan Necas

- translation missing: en.field_release set to 330

#7 - 06/11/2018 01:43 PM - Ivan Necas
- Status changed from Ready For Testing to Closed

#8 - 06/11/2018 08:04 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/5682 added

#9 - 06/14/2018 07:42 AM - Adam Ruzicka
- Related to Bug #23932: ApplicationJob tests fail when run on jenkins from a plugin added
